import { ComponentFixture, TestBed } from '@angular/core/testing';

import { AddGameComponent } from './add-game.component';
import {Team} from '../../models/doppelkopf/enums/team';

describe('AddGameComponent', () => {
  let component: AddGameComponent;
  let fixture: ComponentFixture<AddGameComponent>;

  beforeEach(async () => {
    await TestBed.configureTestingModule({
      declarations: [ AddGameComponent ]
    })
    .compileComponents();

    fixture = TestBed.createComponent(AddGameComponent);
    component = fixture.componentInstance;
    fixture.detectChanges();
  });

  it('should create', () => {
    expect(component).toBeTruthy();
  });

  it('should have the correct score for a normal game', () => {
	  // Set up testing data
	  component.actualPlayers = [
		  {
			  firebonkId: 1,
			  uuid: 'abc-def-ghi-j',
			  firstName: 'Patrick',
			  team: Team.RE,
			  gamePoints: 0,
			  finalCardScore: 123,
		  },
		  {
			  firebonkId: 1,
			  uuid: 'abc-def-ghi-k',
			  firstName: 'Julian',
			  team: Team.RE,
			  gamePoints: 17,
			  finalCardScore: 0,
		  },
		  {
			  firebonkId: 1,
			  uuid: 'abc-def-ghi-l',
			  firstName: 'Yanick',
			  team: Team.CONTRA,
			  gamePoints: 50,
			  finalCardScore: 0,
		  },
		  {
			  firebonkId: 1,
			  uuid: 'abc-def-ghi-m',
			  firstName: 'Janina',
			  team: Team.CONTRA,
			  gamePoints: 50,
			  finalCardScore: 0,
		  },
	  ]

	  component.calculateCurrentScores();

	  expect(component.actualPlayers[0].gamePoints).toEqual(1);
	  expect(component.actualPlayers[1].gamePoints).toEqual(1);
	  expect(component.actualPlayers[2].gamePoints).toEqual(-1);
	  expect(component.actualPlayers[3].gamePoints).toEqual(-1);
  })
});
